package big.epfl.ch.doppler.imageprocessing;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Axel Vandebrouck & Brune Bastide
 *
 */
public class ConfigurationFileReader {
	
	private final String folder;
	
	/**
	 * @param folder : the location of the folder containing the configuration file
	 */
	public ConfigurationFileReader(String folder){
		this.folder = folder;
	}

	/**
	 * @return the colors of the color scale 
	 * @throws IOException if a mistake happens while reading the configuration file 
	 */
	public List<Integer> read() throws IOException {
		List<Integer> colors = new ArrayList<Integer>();
		BufferedReader color = new BufferedReader(new InputStreamReader(
                getClass().getResourceAsStream(folder + "/configurationFile.csv"), StandardCharsets.UTF_8));
        String line;
        while ((line = color.readLine()) != null) {
            String[] colorSplit = line.split(",");
        	colors.add(Integer.parseInt(colorSplit[0])); 
        }
        color.close();
		return colors;
	}
}