package big.epfl.ch.doppler.snake;

import java.awt.Polygon;

import ij.ImagePlus;
import ij.gui.Roi;
import ij.plugin.filter.ExtendedPlugInFilter;
import ij.plugin.filter.PlugInFilterRunner;
import ij.process.FloatProcessor;
import ij.process.ImageProcessor;
import big.epfl.ch.doppler.objects.Point;
import big.ij.snake2D.Snake2DKeeper;
import big.ij.snake2D.Snake2DScale;

public class Esnake_ImageJ_ implements ExtendedPlugInFilter {
	/** Image to process. */
    private ImagePlus imp_ = null;
    /** Input image types allowed. */
    private static final int CAPABILITIES = DOES_8G | DOES_16 | DOES_32 | CONVERT_TO_FLOAT;
    
    private Point[] snakePoints;
    private Polygon p;

	@Override
	public void run(ImageProcessor ip) {
		int maxlife=2000, M=3, detect=1, energyType=1;
		double sigma=3, alpha=0.5;
		boolean immortal = false;
		Roi initialContour = null;
		
		//creation of the snake
		ESnake snake = new ESnake((FloatProcessor)ip, sigma, maxlife, M, alpha, immortal, detect, energyType, initialContour);
		
		// initial position of the snake : 
		/*Snake2DNode[] controlPoints=snake.getNodes();
		Snake2DScale[] curvePoints=snake.getScales();

		for(int i=0;i<controlPoints.length; i++){
			IJ.log("c" + i + "=(" + (int)controlPoints[i].x + ", " + (int)controlPoints[i].y + ")");
		}*/
		
		//Creation of the keeper
		Snake2DKeeper keeper = new Snake2DKeeper();
		
		//Optimization
		keeper.optimize(snake, imp_);
		
		//Get the new position
		Snake2DScale[] curvePoints=snake.getScales(); //curvePoints[0] : control points  curvePoints[1]: points of the curve
		//Snake2DNode[] controlPoints=snake.getNodes();
		
		/*for(int i=0;i<controlPoints.length; i++){
			IJ.log("c" + i + "=(" + (int)controlPoints[i].x + ", " + (int)controlPoints[i].y + ")");
		}*/
		
		int [] X = curvePoints[1].xpoints;
		int [] Y = curvePoints[1].ypoints;
		int n = curvePoints[1].npoints;
		snakePoints = new Point[n];
		for(int i=0; i<snakePoints.length; i++){
			snakePoints[i] = new Point(X[i], Y[i]);
		}
		p = new Polygon(X, Y, n);
	}
	
	public Polygon getPolygon(){
		return p;
	}
	
	public Point[] getSnakePoints(){
		return snakePoints;
	}

	@Override
	public int setup(String arg0, ImagePlus imp) {
		imp_ = imp;
		return(CAPABILITIES);
	}

	@Override
	public void setNPasses(int arg0) {
	}

	/**
	 * This method is called after setup(arg, imp) unless the DONE flag has been set.
	 */
	@Override
	public int showDialog(ImagePlus arg0, String arg1, PlugInFilterRunner arg2) {
		return(CAPABILITIES);
	}
}