package big.epfl.ch.doppler.utilities;

import java.util.List;
import java.util.OptionalDouble;

public class Smoother {
	
	private List<Float> datas;
	private final int DATASMOOTH = 120;
	
	public Smoother(List<Float> datas){
		this.datas = datas;
	}
	
	/**@author raoul
	 * @return a smoothed value of the last few elements of the given list
	 */
	public double smooth(){

		OptionalDouble data = OptionalDouble.empty();
		try{
			data = datas.subList(datas.size()-DATASMOOTH, datas.size()).stream().mapToDouble(a->a).average();
		}catch(IndexOutOfBoundsException e){
			System.out.println("Not enough data.");
		}
		return data.isPresent() ? data.getAsDouble() : 0;
	}

}
